"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _fs = _interopRequireDefault(require("fs"));

var _mkdirp = _interopRequireDefault(require("mkdirp"));

var _path = _interopRequireDefault(require("path"));

var _util = require("@polkadot/util");

var _Serialize = _interopRequireDefault(require("./Serialize"));

var _defaults = _interopRequireDefault(require("./defaults"));

// Copyright 2017-2019 @polkadot/client-db authors & contributors
// This software may be modified and distributed under the terms
// of the Apache-2.0 license. See the LICENSE file for details.
class File extends _Serialize.default {
  constructor(base, file, options) {
    super();
    this._fd = -1;
    this._fileSize = 0;
    this._path = void 0;
    this._file = void 0;
    this._file = file;
    this._path = _path.default.join(base, file);
    this._isCompressed = options && !(0, _util.isUndefined)(options.isCompressed) ? options.isCompressed : false;

    _mkdirp.default.sync(base);
  }

  assertOpen() {
    let open = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
    const test = open ? this._fd !== -1 : this._fd === -1;
    (0, _util.assert)(test, "Expected ".concat(open ? 'an open' : 'a closed', " database"));
  }

  _close() {
    _fs.default.closeSync(this._fd);

    this._fd = -1;
  }

  _open(file) {
    let startEmpty = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

    const isExisting = _fs.default.existsSync(file);

    if (!isExisting || startEmpty) {
      if (isExisting) {
        _fs.default.renameSync(file, "".concat(file, ".").concat(Date.now()));
      }

      _fs.default.writeFileSync(file, Buffer.alloc(_defaults.default.BRANCH_SIZE));
    }

    this._fd = _fs.default.openSync(file, 'r+');
    this._fileSize = _fs.default.fstatSync(this._fd).size;
  }

}

exports.default = File;