/// <reference types="node" />
import { Key, NibbleBuffer, Value } from './types';
import Cache from './Cache';
export default class Impl extends Cache {
    protected _getKeyValue(keyAt: number): Buffer;
    protected _retrieveBranch(doCreate: boolean, branch: Buffer, entryIndex: number, keyIndex: number, key: NibbleBuffer): Key | null;
    protected _retrieveEmpty(doCreate: boolean, branch: Buffer, branchAt: number, entryIndex: number, key: NibbleBuffer): Key | null;
    protected _retrieveLeaf(doCreate: boolean, branch: Buffer, branchAt: number, entryIndex: number, keyIndex: number, key: NibbleBuffer): Key | null;
    protected _findKey(key: NibbleBuffer, doCreate: boolean, keyIndex: number, branchAt: number): Key | null;
    protected _extractValueInfo(keyValue: Buffer): {
        valueAt: number;
        valueLength: number;
    };
    protected _readValue(keyValue: Buffer): Value;
    protected _writeValue(keyAt: number, keyValue: Buffer, value: Buffer): Value;
    protected _writeNewKey(key: NibbleBuffer): Key;
    protected writeNewKey(key: NibbleBuffer): Key;
    protected _writeNewBranch(branch: Buffer, branchAt: number, entryIndex: number, key: NibbleBuffer, prevAt: number, prevKey: NibbleBuffer, matchIndex: number, depth: number): Key;
    protected writeNewBranch(branch: Buffer, branchAt: number, entryIndex: number, key: NibbleBuffer, prevAt: number, prevValue: NibbleBuffer, matchIndex: number, depth: number): Key;
    protected _writeNewLeaf(branch: Buffer, branchAt: number, entryIndex: number, key: NibbleBuffer): Key;
    protected writeNewLeaf(branch: Buffer, branchAt: number, entryIndex: number, key: NibbleBuffer): Key;
    protected _writeUpdatedBuffer(buffer: Buffer, bufferAt: number): number;
    protected _writeNewBuffer(buffer: Buffer, withCache?: boolean): number;
    protected _writeNewBuffers(buffers: Array<Buffer>): number;
}
