"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _snappy = _interopRequireDefault(require("snappy"));

var _util = require("@polkadot/trie-codec/util");

var _util2 = require("@polkadot/util");

var _defaults = _interopRequireDefault(require("./defaults"));

// Copyright 2017-2019 @polkadot/client-db authors & contributors
// This software may be modified and distributed under the terms
// of the Apache-2.0 license. See the LICENSE file for details.
class Serialize {
  constructor() {
    this._isCompressed = false;
  }

  _deserializeValue(value) {
    return (0, _util2.bufferToU8a)(this._isCompressed ? _snappy.default.uncompressSync(value) : value);
  }

  _serializeValue(value) {
    return this._isCompressed ? _snappy.default.compressSync((0, _util2.u8aToBuffer)(value)) : (0, _util2.u8aToBuffer)(value);
  }

  _serializeKey(u8a) {
    (0, _util2.assert)(u8a.length <= _defaults.default.KEY_SIZE, "".concat((0, _util2.u8aToHex)(u8a), " too large, expected <= 32 bytes"));
    let buffer;
    let full;

    if (u8a.length === _defaults.default.KEY_SIZE) {
      full = u8a;
    } else {
      full = new Uint8Array(_defaults.default.KEY_SIZE);
      full.set(u8a, 0);
    }

    buffer = (0, _util2.u8aToBuffer)(full);
    return {
      buffer,
      parts: _defaults.default.KEY_IS_NIBBLES ? (0, _util.toNibbles)(full) : full
    };
  }

}

exports.default = Serialize;