"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _mkdirp = _interopRequireDefault(require("mkdirp"));

var _path = _interopRequireDefault(require("path"));

var _rimraf = _interopRequireDefault(require("rimraf"));

var _chainspec = require("@polkadot/chainspec");

var _trieDb = _interopRequireDefault(require("@polkadot/trie-db"));

var _util = require("@polkadot/util");

var _DiskDb = _interopRequireDefault(require("../../DiskDb"));

// Copyright 2017-2019 @polkadot/client-db authors & contributors
// This software may be modified and distributed under the terms
// of the Apache-2.0 license. See the LICENSE file for details.
describe.skip('DB via a trie', () => {
  const location = _path.default.join(process.cwd(), '--test-FileFlatDb-ViaTrie');

  const raw = _chainspec.alexander.genesis.raw,
        genesisRoot = _chainspec.alexander.genesisRoot;
  beforeAll(() => {
    _rimraf.default.sync(location);

    _mkdirp.default.sync(location);
  });
  it('creates a trie with the correct root', () => {
    const trie = new _trieDb.default(new _DiskDb.default(location, 'test.db', {
      isNative: true
    }));
    trie.open();
    trie.transaction(() => {
      Object.keys(raw).forEach(key => {
        trie.put((0, _util.hexToU8a)(key), (0, _util.hexToU8a)(raw[key]));
      });
      return true;
    });
    expect((0, _util.u8aToHex)(trie.getRoot())).toEqual(genesisRoot);
  });
  describe('re-opens and has all the correct keys', () => {
    const trie = new _trieDb.default(new _DiskDb.default(location, 'test.db', {
      isNative: true
    }));
    trie.open();
    trie.setRoot((0, _util.hexToU8a)(genesisRoot));
    Object.keys(raw).forEach(key => {
      it(key, () => {
        expect((0, _util.u8aToHex)(trie.get((0, _util.hexToU8a)(key)))).toEqual(raw[key]);
      });
    });
  });
});