/// <reference types="node" />
import { BaseDb, BaseDbOptions, ProgressCb } from '@polkadot/db/types';
import { Key, NibbleBuffer, Value } from './types';
import Impl from './Impl';
export default class FileFlatDb extends Impl implements BaseDb {
    constructor(base: string, file?: string, options?: BaseDbOptions);
    open(): void;
    close(): void;
    drop(): void;
    empty(): void;
    size(): number;
    rename(base: string, file: string): void;
    maintain(fn: ProgressCb): void;
    del(key: Uint8Array): void;
    get(key: Uint8Array): Uint8Array | null;
    put(key: Uint8Array, value: Uint8Array): void;
    protected findKey(key: NibbleBuffer, doCreate: boolean): Key | null;
    protected readValue({ keyValue }: Key): Value;
    protected writeValue({ keyAt, keyValue }: Key, value: Buffer): Value;
}
